!*****Revision Informations Automatically Generated by VisualSVN*****!
!---------------------------------------------------------------------
!> $ID:$
!> $Revision: 609 $
!> $Author: dsu $
!> $Date: 2018-09-14 11:47:55 -0700 (Fri, 14 Sep 2018) $
!> $URL: https://biot.eos.ubc.ca/svn/min3p_thcm/branches/dsu_new_add_2023Jan/src/min3p/findstrg.F90 $
!---------------------------------------------------------------------
!********************************************************************!

!c ----------------------------------------------------------------------
!c subroutine findstrg
!c -------------------
!c
!c find text string in data file       
!c
!c written by:      Uli Mayer - February 12, 98
!c
!c last modified:
!c                  Danyang Su   - Sept. 10, 2018
!c                  Add support for length of maximum input data
!c                  (e.g., dbs path) to 256
!c
!c definition of variables:
!c
!c I --> on input   * arbitrary  - initialized  + entries expected
!c O --> on output  * arbitrary  - unaltered    + altered
!c                                                                    I O
!c passed:   integer*4:
!c           ----------
!c           itmp
!c
!c           logical:
!c           ---------
!c           found_subsection
!c
!c           character:
!c           ----------
!c           subsection
!c
!c common:   -
!c
!c local:    character:
!c           ----------
!c           string
!c
!c external: -
!c ----------------------------------------------------------------------
 
      subroutine findstrg(subsection,itmp,found_subsection)
      
      implicit none

      character*72 subsection
      integer itmp
      logical found_subsection
!c  change from 72 to 256 to support long string, e.g., database full path
      character*256 string
 
!c  rewind input file

      rewind(itmp)

!c  search for test string in input file

      found_subsection = .false.
      do while (.not.found_subsection)
        read(itmp,*,err=999,end=999) string
        if (string.eq.subsection) then
          found_subsection = .true.
        end if
      end do

999   return
      end

      
      subroutine findstrginzone(subsection,itmp,found_subsection)
      
      implicit none

      character*72 subsection
      integer itmp
      logical found_subsection      
!c  change from 72 to 256 to support long string, e.g., database full path
      character*256 string
 
!c  rewind input file

      rewind(itmp)

!c  search for test string in input file

      found_subsection = .false.
      do while (.not.found_subsection)
        read(itmp,*,err=999,end=999) string
        if (string.eq.subsection) then
          found_subsection = .true.
        end if
        if (string.eq.'end of zone') then 
            go to 999
        end if
        
      end do

999   return
      end

    
      subroutine findstrginblock(strblockname,subsection,itmp,found_subsection)
      
      implicit none

      character*72 strblockname
      character*72 subsection
      integer itmp
      logical found_subsection
!c  change from 72 to 256 to support long string, e.g., database full path
      character*256 string
 
!c  rewind input file

      rewind(itmp)

!c  search for test string in input file

      found_subsection = .false.
      do while (.not.found_subsection)
        read(itmp,*,err=999,end=999) string
        if (string.eq.strblockname) then
          do while (.not.found_subsection)
            read(itmp,*,err=999,end=999) string
            if (string.eq.subsection) then
              found_subsection = .true.
              goto 999
            end if
            if (string.eq.'done') then 
                goto 999
            end if            
          end do
          goto 999
        end if     
      end do
      
999   rewind(itmp)

      return
      end
