!*****Revision Informations Automatically Generated by VisualSVN*****!
!---------------------------------------------------------------------
!> $ID:$
!> $Revision: 826 $
!> $Author: dsu $
!> $Date: 2022-03-24 10:10:16 -0700 (Thu, 24 Mar 2022) $
!> $URL: https://biot.eos.ubc.ca/svn/min3p_thcm/branches/dsu_new_add_2023Jan/src/min3p/parm.F90 $
!---------------------------------------------------------------------
!********************************************************************!

      module parm
      
      implicit none

! ----------------------------------------------------------------------
! precision and parameter settings for min3p
!
! ----------------------------------------------------------------------
! precision: 
! ----------

      integer, parameter :: type_i8 = selected_int_kind(15)
      integer, parameter :: type_i4 = selected_int_kind(9)
      integer, parameter :: type_i2 = selected_int_kind(4)
      integer, parameter :: type_i1 = selected_int_kind(2)
      integer, parameter :: type_r4 = kind(1.0e0)
      integer, parameter :: type_r8 = kind(1.0d0)

! ----------------------------------------------------------------------
! parameter definitions:
! ----------------------
!           ncon             = number of node connections
!                              = 3 (1D-problem)
!                              = 5 (2D-problem)
!                              = 7 (3D-problem)
!           ncon_usg_est     = estimated number of node-node connections for usg mesh
!           ncon_usg         = actual maximum number of node-node connections for usg mesh
!           ncon_cell_usg    = actual maximum number of maximum cells attached to a node
!           maxndr           = max. number of parallel dissolution
!                              reactions for one mineral
!           maxnpr           = max. number of parallel precipitation 
!                              reactions for one mineral
!           maxnrc           = max. number of component or complexed 
!                              secondary aqueous species involved 
!                              in dissolution-precipitation 
!                              reactions for one mineral
!           maxnor           = max. number of parallel oxidation/
!                              reduction reactions for redox couple
! ----------------------------------------------------------------------

      integer (type_i4), parameter :: ncon=7

      integer (type_i4), parameter :: maxndr=10
      integer (type_i4), parameter :: maxnpr=10
      integer (type_i4), parameter :: maxnrc=20
      integer (type_i4), parameter :: maxnor=10

      end module parm
