!*****Revision Informations Automatically Generated by VisualSVN*****!
!---------------------------------------------------------------------
!> $ID:$
!> $Revision: 826 $
!> $Author: dsu $
!> $Date: 2022-03-24 10:10:16 -0700 (Thu, 24 Mar 2022) $
!> $URL: https://biot.eos.ubc.ca/svn/min3p_thcm/branches/dsu_new_add_2023Jan/src/solver/petsc_mpi_common.F90 $
!---------------------------------------------------------------------
!********************************************************************!

!> module: solver_ksp_common
!>
!> written by: Danyang Su
!>
!> module description:
!>
!> Module of linear functions 
!>
!> Note: 
!> See http://www.mcs.anl.gov/petsc/ for detail


module petsc_mpi_common

#ifdef PETSC
#include <petscversion.h>
#if (PETSC_VERSION_MAJOR >= 3 && PETSC_VERSION_MINOR >= 8)
#include <petsc/finclude/petscsys.h>
    use petscsys
#endif
#endif

    implicit none
    
#ifdef PETSC
#if (PETSC_VERSION_MAJOR >= 3 && PETSC_VERSION_MINOR >= 6 && PETSC_VERSION_MINOR < 8)
#include <petsc/finclude/petscsys.h>
#elif (PETSC_VERSION_MAJOR >= 3 && PETSC_VERSION_MINOR < 6)
#include <finclude/petscsys.h>
#endif
#endif

#ifdef PETSC
    MPI_Comm :: Petsc_Comm_Group
#endif

    contains
    
    !> Initialize petsc 
    subroutine petsc_mpi_initialize(rank,nprcs) 

        implicit none        

        integer*4 :: rank
        integer*4 :: nprcs
        
#ifdef PETSC
        PetscErrorCode :: ierr
#endif

#ifdef PETSC
        call PetscInitialize(Petsc_Null_Character,ierr)  
        CHKERRQ(ierr)
        call MPI_Comm_rank(Petsc_Comm_World,rank,ierr)
        CHKERRQ(ierr)
        call MPI_Comm_size(Petsc_Comm_World,nprcs,ierr)
        CHKERRQ(ierr)
#endif
        
    end subroutine petsc_mpi_initialize
    
    !> Release solver space and end parallel region
    subroutine petsc_mpi_finalize

        implicit none
        
#ifdef PETSC
        PetscErrorCode :: ierr
        call PetscFinalize(ierr)
        CHKERRQ(ierr)
#endif
        
    end subroutine petsc_mpi_finalize
    
    !> MPI Barrier
    subroutine petsc_mpi_barrier

        implicit none
        
#ifdef PETSC
        integer :: ierr
        call MPI_Barrier(Petsc_Comm_World, ierr)
        CHKERRQ(ierr)
#endif
    
    end subroutine petsc_mpi_barrier
    
end module petsc_mpi_common
